﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Textgenerator
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            string muster = File.ReadAllText(@"..\..\..\..\Faust.txt");

            foreach (var item in ".,;:!?\"\r\n»«–*")
	        {
                muster = muster.Replace(item, ' ');
	        }

            // Text in _Unterstrichen_ und mehrfache Leerzeichen entfernen
            bool regieanweisung = false;
            bool rundeKlammer = false;
            bool eckigeKlammer = false;
            StringBuilder gesäubert = new StringBuilder();
            for (int i = 0; i < muster.Length; i++)
            {
                if(muster[i] == '_')
                {
                    regieanweisung = !regieanweisung;
                }
                else if(muster[i] == '(')
                {
                    rundeKlammer = true;
                }
                else if(muster[i] == ')')
                {
                    rundeKlammer = false;
                }
                else if (muster[i] == '[')
                {
                    eckigeKlammer = true;
                }
                else if (muster[i] == ']')
                {
                    eckigeKlammer = false;
                }
                else if (!regieanweisung && !rundeKlammer && !eckigeKlammer
                      && !(muster[i] == ' '
                           && (gesäubert.Length == 0 
                               || gesäubert[gesäubert.Length - 1] == ' ')))
                {
                    gesäubert.Append(muster[i]);
                }
            }
            string gesäubertString = gesäubert.ToString().ToLower();
            string[] wörter = gesäubertString.Split(' ');

            int n = 3;
            List<NGramm> ngramme = new List<NGramm>();
            for (int i = 0; i < wörter.Length - n; i++)
            {
                // Nehme die nächsten n Wörter.
                // Gibt es dazu schon ein N-Gramm?
                NGramm aktuellesNGramm = null;
                foreach (var item in ngramme)
                {
                    bool treffer = true;
                    for (int j = 0; j < n; j++)
                    {
                        if(item.Wörter[j] != wörter[i+j])
                        {
                            treffer = false;
                            break;
                        }
                    }
                    if(treffer)
                    {
                        aktuellesNGramm = item;
                        break;
                    }
                }
                if (aktuellesNGramm != null) // Falls ja: Speichere Folgewort in N-Gramm.  
                {
                    aktuellesNGramm.Folgewörter.Add(wörter[i+n]);
                }
                else // Falls nein: Erzeuge N-Gramm mit Folgewort.
                {
                    ngramme.Add(new NGramm());
                    string[] w = new string[n];
                    for (int k = 0; k < n; k++)
                    {
                        w[k] = wörter[i + k];
                    }
                    ngramme.Last().Wörter = w;
                    ngramme.Last().Folgewörter.Add(wörter[i + n]);
                }
            }

            // nach Video eingefügt: N-Gramme nach Häufigkeit ordnen
            ngramme = ngramme.OrderByDescending(x => x.Folgewörter.Count).ToList();

            Random zufall = new Random();
            List<string> generierteWörter = new List<string>();
            NGramm g = ngramme[zufall.Next(ngramme.Count)];
            for (int i = 0; i < n; i++)
            {
                generierteWörter.Add(g.Wörter[i]);
            }

            for (int i = 0; i < 1000; i++)
            {
                NGramm aktuellesNGramm = null;

                foreach (var item in ngramme)
                {
                    bool treffer = true;
                    for (int j = 0; j < n; j++)
                    {
                        if (item.Wörter[j] != generierteWörter[generierteWörter.Count - n + j])
                        {
                            treffer = false;
                        }
                    }
                    if (treffer)
                    {
                        aktuellesNGramm = item;
                        break;
                    }
                }

                generierteWörter.Add(
                    aktuellesNGramm.Folgewörter[
                        zufall.Next(aktuellesNGramm.Folgewörter.Count)]);
            }

            // Hausaufgabe: Ergebnis als Textdatei speichern.
        }
    }
}
